head	1.2;
access;
symbols;
locks;
comment	@ * @;


1.2
date	2006.05.26.15.59.50;	author Average;	state Exp;
branches;
next	1.1;

1.1
date	2006.05.19.16.10.58;	author Average;	state Exp;
branches;
next	;


desc
@@


1.2
log
@ƃC^[tF[Xς܂
@
text
@{******************************************************************************}
{* DCPcrypt v2.0 written by David Barton (crypto@@cityinthesky.co.uk) **********}
{******************************************************************************}
{* A binary compatible implementation of Blowfish *****************************}
{******************************************************************************}
{* Copyright (c) 1999-2002 David Barton                                       *}
{* Permission is hereby granted, free of charge, to any person obtaining a    *}
{* copy of this software and associated documentation files (the "Software"), *}
{* to deal in the Software without restriction, including without limitation  *}
{* the rights to use, copy, modify, merge, publish, distribute, sublicense,   *}
{* and/or sell copies of the Software, and to permit persons to whom the      *}
{* Software is furnished to do so, subject to the following conditions:       *}
{*                                                                            *}
{* The above copyright notice and this permission notice shall be included in *}
{* all copies or substantial portions of the Software.                        *}
{*                                                                            *}
{* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR *}
{* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,   *}
{* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    *}
{* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER *}
{* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING    *}
{* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER        *}
{* DEALINGS IN THE SOFTWARE.                                                  *}
{******************************************************************************}
UNIT blowfish;

INTERFACE
USES
  Classes, Sysutils, crypt2, ciphers;
CONST
  id_blowfish=32;

TYPE
  TDCP_blowfish= CLASS(TDCP_blockcipher64)
  PROTECTED
    SBox: ARRAY[0..3,0..255] OF DWord;
    PBox: ARRAY[0..17] OF DWord;
    PROCEDURE InitKey(CONST Key; Size: longword); override;
  PUBLIC
    CLASS FUNCTION GetId: INTEGER; override;
    CLASS FUNCTION GetAlgorithm: string; override;
    CLASS FUNCTION GetMaxKeySize: INTEGER; override;
    CLASS FUNCTION SelfTest: BOOLEAN; override;
    PROCEDURE Burn; override;
    PROCEDURE EncryptECB(CONST InData; VAR OutData); override;
    PROCEDURE DecryptECB(CONST InData; VAR OutData); override;
  END;


{******************************************************************************}
{******************************************************************************}
IMPLEMENTATION
{$R-}{$Q-}
{$I blowfish.inc}

CLASS FUNCTION TDCP_blowfish.GetID: INTEGER;
BEGIN
  Result:= id_blowfish;
END;

CLASS FUNCTION TDCP_blowfish.GetAlgorithm: string;
BEGIN
  Result:= 'Blowfish';
END;

CLASS FUNCTION TDCP_blowfish.GetMaxKeySize: INTEGER;
BEGIN
  Result:= 448;
END;

CLASS FUNCTION TDCP_blowfish.SelfTest: BOOLEAN;
CONST
  Key1: ARRAY[0..7] OF BYTE= ($00,$00,$00,$00,$00,$00,$00,$00);
  Key2: ARRAY[0..7] OF BYTE= ($7C,$A1,$10,$45,$4A,$1A,$6E,$57);
  InData1: ARRAY[0..7] OF BYTE= ($00,$00,$00,$00,$00,$00,$00,$00);
  InData2: ARRAY[0..7] OF BYTE= ($01,$A1,$D6,$D0,$39,$77,$67,$42);
  OutData1: ARRAY[0..7] OF BYTE= ($4E,$F9,$97,$45,$61,$98,$DD,$78);
  OutData2: ARRAY[0..7] OF BYTE= ($59,$C6,$82,$45,$EB,$05,$28,$2B);
VAR
  Cipher: TDCP_blowfish;
  Data: ARRAY[0..7] OF BYTE;
BEGIN
  Cipher:= TDCP_blowfish.Create;
  Cipher.Init(Key1,Sizeof(Key1)*8,NIL);
  Cipher.EncryptECB(InData1,Data);
  Result:= BOOLEAN(CompareMem(@@Data,@@OutData1,Sizeof(Data)));
  Cipher.Reset;
  Cipher.DecryptECB(Data,Data);
  Result:= BOOLEAN(CompareMem(@@Data,@@InData1,Sizeof(Data))) AND Result;
  Cipher.Burn;
  Cipher.Init(Key2,Sizeof(Key2)*8,NIL);
  Cipher.EncryptECB(InData2,Data);
  Result:= BOOLEAN(CompareMem(@@Data,@@OutData2,Sizeof(Data))) AND Result;
  Cipher.Reset;
  Cipher.DecryptECB(Data,Data);
  Result:= BOOLEAN(CompareMem(@@Data,@@InData2,Sizeof(Data))) AND Result;
  Cipher.Burn;
  Cipher.Free;
END;

PROCEDURE TDCP_blowfish.InitKey(CONST Key; Size: longword);
VAR
  i, k: longword;
  A: DWord;
  KeyB: PByteArray;
  Block: ARRAY[0..7] OF BYTE;
BEGIN
  Size:= Size div 8;
  KeyB:= @@Key;
  Move(SBoxOrg,SBox,Sizeof(SBox));
  Move(PBoxOrg,PBox,Sizeof(PBox));
  k:= 0;
  FOR i:= 0 TO 17 DO
  BEGIN
    A:= dword(KeyB^[(k+3) mod Size]);
    A:= A + (dword(KeyB^[(k+2) mod Size]) shl 8);
    A:= A + (dword(KeyB^[(k+1) mod Size]) shl 16);
    A:= A + (dword(KeyB^[k]) shl 24);
    PBox[i]:= PBox[i] xor A;
    k:= (k+4) mod Size;
  END;
  FillChar(Block,Sizeof(Block),0);
  FOR i:= 0 TO 8 DO
  BEGIN
    EncryptECB(Block,Block);
    PBox[i*2]:= dword(Block[3]) + (dword(Block[2]) shl 8) + (dword(Block[1]) shl 16) + (dword(Block[0]) shl 24);
    PBox[i*2+1]:= dword(Block[7]) + (dword(Block[6]) shl 8) + (dword(Block[5]) shl 16) + (dword(Block[4]) shl 24);
  END;
  FOR k:= 0 TO 3 DO
  BEGIN
    FOR i:= 0 TO 127 DO
    BEGIN
      EncryptECB(Block,Block);
      SBox[k,i*2]:= dword(Block[3]) + (dword(Block[2]) shl 8) + (dword(Block[1]) shl 16) + (dword(Block[0]) shl 24);
      SBox[k,i*2+1]:= dword(Block[7]) + (dword(Block[6]) shl 8) + (dword(Block[5]) shl 16) + (dword(Block[4]) shl 24);
    END;
  END;
END;

PROCEDURE TDCP_blowfish.Burn;
BEGIN
  FillChar(SBox,Sizeof(SBox),$FF);
  FillChar(PBox,Sizeof(PBox),$FF);
  inherited Burn;
END;

PROCEDURE TDCP_blowfish.EncryptECB(CONST InData; VAR OutData);
VAR
  xL, xR: DWord;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  xL:= Pdword(@@InData)^;
  xR:= Pdword(longword(@@InData)+4)^;
  xL:= ((xL AND $FF) shl 24) OR ((xL AND $FF00) shl 8) OR ((xL AND $FF0000) shr 8) OR ((xL AND $FF000000) shr 24);
  xR:= ((xR AND $FF) shl 24) OR ((xR AND $FF00) shl 8) OR ((xR AND $FF0000) shr 8) OR ((xR AND $FF000000) shr 24);
  xL:= xL xor PBox[0];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[1];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[2];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[3];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[4];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[5];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[6];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[7];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[8];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[9];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[10];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[11];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[12];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[13];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[14];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[15];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[16];
  xR:= xR xor PBox[17];
  xL:= ((xL AND $FF) shl 24) OR ((xL AND $FF00) shl 8) OR ((xL AND $FF0000) shr 8) OR ((xL AND $FF000000) shr 24);
  xR:= ((xR AND $FF) shl 24) OR ((xR AND $FF00) shl 8) OR ((xR AND $FF0000) shr 8) OR ((xR AND $FF000000) shr 24);
  Pdword(@@OutData)^:= xR;
  Pdword(longword(@@OutData)+4)^:= xL;
END;

PROCEDURE TDCP_blowfish.DecryptECB(CONST InData; VAR OutData);
VAR
  xL, xR: DWord;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  xL:= Pdword(@@InData)^;
  xR:= Pdword(longword(@@InData)+4)^;
  xL:= (xL shr 24) OR ((xL shr 8) AND $FF00) OR ((xL shl 8) AND $FF0000) OR (xL shl 24);
  xR:= (xR shr 24) OR ((xR shr 8) AND $FF00) OR ((xR shl 8) AND $FF0000) OR (xR shl 24);
  xL:= xL xor PBox[17];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[16];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[15];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[14];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[13];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[12];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[11];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[10];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[9];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[8];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[7];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[6];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[5];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[4];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[3];
  xR:= xR xor (((SBox[0,(xL shr 24) AND $FF] + SBox[1,(xL shr 16) AND $FF]) xor
    SBox[2,(xL shr 8) AND $FF]) + SBox[3,xL AND $FF]) xor PBox[2];
  xL:= xL xor (((SBox[0,(xR shr 24) AND $FF] + SBox[1,(xR shr 16) AND $FF]) xor
    SBox[2,(xR shr 8) AND $FF]) + SBox[3,xR AND $FF]) xor PBox[1];
  xR:= xR xor PBox[0];
  xL:= (xL shr 24) OR ((xL shr 8) AND $FF00) OR ((xL shl 8) AND $FF0000) OR (xL shl 24);
  xR:= (xR shr 24) OR ((xR shr 8) AND $FF00) OR ((xR shl 8) AND $FF0000) OR (xR shl 24);
  Pdword(@@OutData)^:= xR;
  Pdword(longword(@@OutData)+4)^:= xL;
END;

END.
@


1.1
log
@Initial revision
@
text
@d25 1
a25 1
unit blowfish;
d27 2
a28 2
interface
uses
d30 1
a30 1
const
d33 15
a47 15
type
  TDCP_blowfish= class(TDCP_blockcipher64)
  protected
    SBox: array[0..3,0..255] of DWord;
    PBox: array[0..17] of DWord;
    procedure InitKey(const Key; Size: longword); override;
  public
    class function GetId: integer; override;
    class function GetAlgorithm: string; override;
    class function GetMaxKeySize: integer; override;
    class function SelfTest: boolean; override;
    procedure Burn; override;
    procedure EncryptECB(const InData; var OutData); override;
    procedure DecryptECB(const InData; var OutData); override;
  end;
d52 1
a52 1
implementation
d56 2
a57 2
class function TDCP_blowfish.GetID: integer;
begin
d59 1
a59 1
end;
d61 2
a62 2
class function TDCP_blowfish.GetAlgorithm: string;
begin
d64 1
a64 1
end;
d66 2
a67 2
class function TDCP_blowfish.GetMaxKeySize: integer;
begin
d69 1
a69 1
end;
d71 9
a79 9
class function TDCP_blowfish.SelfTest: boolean;
const
  Key1: array[0..7] of byte= ($00,$00,$00,$00,$00,$00,$00,$00);
  Key2: array[0..7] of byte= ($7C,$A1,$10,$45,$4A,$1A,$6E,$57);
  InData1: array[0..7] of byte= ($00,$00,$00,$00,$00,$00,$00,$00);
  InData2: array[0..7] of byte= ($01,$A1,$D6,$D0,$39,$77,$67,$42);
  OutData1: array[0..7] of byte= ($4E,$F9,$97,$45,$61,$98,$DD,$78);
  OutData2: array[0..7] of byte= ($59,$C6,$82,$45,$EB,$05,$28,$2B);
var
d81 2
a82 2
  Data: array[0..7] of byte;
begin
d84 1
a84 1
  Cipher.Init(Key1,Sizeof(Key1)*8,nil);
d86 1
a86 1
  Result:= boolean(CompareMem(@@Data,@@OutData1,Sizeof(Data)));
d89 1
a89 1
  Result:= boolean(CompareMem(@@Data,@@InData1,Sizeof(Data))) and Result;
d91 1
a91 1
  Cipher.Init(Key2,Sizeof(Key2)*8,nil);
d93 1
a93 1
  Result:= boolean(CompareMem(@@Data,@@OutData2,Sizeof(Data))) and Result;
d96 1
a96 1
  Result:= boolean(CompareMem(@@Data,@@InData2,Sizeof(Data))) and Result;
d99 1
a99 1
end;
d101 2
a102 2
procedure TDCP_blowfish.InitKey(const Key; Size: longword);
var
d106 2
a107 2
  Block: array[0..7] of byte;
begin
d113 2
a114 2
  for i:= 0 to 17 do
  begin
d121 1
a121 1
  end;
d123 2
a124 2
  for i:= 0 to 8 do
  begin
d128 5
a132 5
  end;
  for k:= 0 to 3 do
  begin
    for i:= 0 to 127 do
    begin
d136 3
a138 3
    end;
  end;
end;
d140 2
a141 2
procedure TDCP_blowfish.Burn;
begin
d145 1
a145 1
end;
d147 2
a148 2
procedure TDCP_blowfish.EncryptECB(const InData; var OutData);
var
d150 2
a151 2
begin
  if not fInitialized then
d155 2
a156 2
  xL:= ((xL and $FF) shl 24) or ((xL and $FF00) shl 8) or ((xL and $FF0000) shr 8) or ((xL and $FF000000) shr 24);
  xR:= ((xR and $FF) shl 24) or ((xR and $FF00) shl 8) or ((xR and $FF0000) shr 8) or ((xR and $FF000000) shr 24);
d158 32
a189 32
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[1];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[2];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[3];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[4];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[5];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[6];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[7];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[8];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[9];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[10];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[11];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[12];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[13];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[14];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[15];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[16];
d191 2
a192 2
  xL:= ((xL and $FF) shl 24) or ((xL and $FF00) shl 8) or ((xL and $FF0000) shr 8) or ((xL and $FF000000) shr 24);
  xR:= ((xR and $FF) shl 24) or ((xR and $FF00) shl 8) or ((xR and $FF0000) shr 8) or ((xR and $FF000000) shr 24);
d195 1
a195 1
end;
d197 2
a198 2
procedure TDCP_blowfish.DecryptECB(const InData; var OutData);
var
d200 2
a201 2
begin
  if not fInitialized then
d205 2
a206 2
  xL:= (xL shr 24) or ((xL shr 8) and $FF00) or ((xL shl 8) and $FF0000) or (xL shl 24);
  xR:= (xR shr 24) or ((xR shr 8) and $FF00) or ((xR shl 8) and $FF0000) or (xR shl 24);
d208 32
a239 32
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[16];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[15];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[14];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[13];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[12];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[11];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[10];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[9];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[8];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[7];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[6];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[5];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[4];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[3];
  xR:= xR xor (((SBox[0,(xL shr 24) and $FF] + SBox[1,(xL shr 16) and $FF]) xor
    SBox[2,(xL shr 8) and $FF]) + SBox[3,xL and $FF]) xor PBox[2];
  xL:= xL xor (((SBox[0,(xR shr 24) and $FF] + SBox[1,(xR shr 16) and $FF]) xor
    SBox[2,(xR shr 8) and $FF]) + SBox[3,xR and $FF]) xor PBox[1];
d241 2
a242 2
  xL:= (xL shr 24) or ((xL shr 8) and $FF00) or ((xL shl 8) and $FF0000) or (xL shl 24);
  xR:= (xR shr 24) or ((xR shr 8) and $FF00) or ((xR shl 8) and $FF0000) or (xR shl 24);
d245 1
a245 1
end;
d247 1
a247 1
end.
@
