(**$Revision: 1.1.1.1 $**)
UNIT KRUnit;
INTERFACE
USES
    Classes,os2base,os2def,os2pmapi,strings,SysUtils,VPUtils,Dos,
    Cell,xmlRead,xmlWrite,dom,XMLCrypt;

{$I krmini.inc}

(* Static Variables *)

CONST
    BKS_TABBEDDIALOG = $00000800;  (* Tabbed dialog         *)
    BKS_MAJORTABTOP  = $00000040;  (* Major tabs top        *)

(**xml path constant**)
CONST
    CopyToIndex   = 2000;
    MoveToIndex   = 2100;

    MainPath      ='KeyRingData';

    GroupPath     ='Page';
    GroupStylePath='Style';
    AppNameAttr   ='Application';
    ColumStyle    ='ColumnStyle';
    ColumItem     ='Column';
    ColumName     ='name';
    ColumOrder    ='order';
    ColumDisp     ='disp';

    GroupNameAttr ='name';
    GroupInfoAttr ='info';
    ItemPath      ='Item';

    MaxColumList    =9;
    MaxCharLength   =4096;
    ExpireCheckConst='ExpireCheck';

    ppNbFont:pchar  ='9.WarpSans';
    pHideConst      ='--------';
    CX_SPLITBAR     = 180;
    ulColumStyle:ULong=CFA_HORZSEPARATOR OR CFA_LEFT OR CFA_SEPARATOR;
    ulTitleStyle:ULong=CFA_STRING OR CFA_LEFT OR CFA_FITITLEREADONLY;

    BlankStr='----';

TYPE
    pCharArray =ARRAY[1..MaxColumList] OF pChar;
    ColumToSuffixArray=ARRAY[1..MaxColumList] OF RECORD
                          ix:INTEGER;
                          isDisp:BOOLEAN;
                       END;


CONST
    ColumList:pCharArray=
        ('Icon',    'Description', 'User',
         'Password','URL',         'Serial Number',
         'Memo',    'Last Update', 'Expiry Date');
    ColumAttrList:ARRAY[1..MaxColumList] OF String=
        ('icon',    'description', 'user',
         'password','URL',         'serial_number',
         'memo',    'last_update', 'expiry_date');
    ErrorMsgLength=80;
VAR
    DefaultColumToSuffix:ColumToSuffixArray;//Colum TO pChAry
    ErrorMsgWnd:HWND;
    pChLoadError,pChSaveError:ARRAY[1..ErrorMsgLength] OF CHAR;


FUNCTION FileToXML(isKeyword:BOOLEAN;
                   key:string;
                   AStream:TFileStream):TXMLDocument;
PROCEDURE XMLToFile(isKeyword:BOOLEAN;
                    key:string;
                    AStream:TFileStream;
                    DOC:TXMLDocument);

TYPE
    DispStateEnum=(normal,hide,nodisp);
    ptClientData = ^tClientData;
    tClientData = RECORD
        hwndCnr   : HWnd;
        hptrIcon  : HPointer;
    END;
    pRowInfo = ^RowInfoRecord;
    RowInfoRecord = RECORD
        Core   : RECORDCORE;
        pChAry : pCharArray;
        isExpireCheck:bool;
        pChHide: pChar;
    END;

TYPE
    KrXMLDocClass=CLASS
        isUseCrypt:BOOLEAN;
        password:string;
        constructor Create;
        FUNCTION isKrDoc(FN:String):BOOLEAN;
        FUNCTION GetMaxColum:INTEGER;
        FUNCTION GetFirstPage:TDOMNode;
        FUNCTION GetMaxPage:INTEGER;
        FUNCTION GetMaxPageNode(GroupNode:TDOMNode):INTEGER;
        PROCEDURE FlushXMLData;
        FUNCTION CreatePageData(PageName,PageInfoSt:String):TDOMNode;
        FUNCTION CreatePageItemData(PageNode:TDOMNode;N:String):TDOMElement;
        PROCEDURE SetNodeAttr(node:TDOMELement;suffix:INTEGER;pRow:pRowInfo);
        PROCEDURE SetFileName(st:string);
        FUNCTION GetFileName:String;
        PROCEDURE SaveDoc;
        FUNCTION isDoc:BOOLEAN;
        PROCEDURE MakeNewDoc;
      PRIVATE
        DocFileName:string;
        MaxColumNumber:INTEGER;
        Doc:TXMLDocument;
    END;

    ContainerClass=CLASS
        id:ULong;
        krDoc:krXMLDocClass;
        GroupName:string;
        GroupInfoStr:String;
        AppName:String;
        isFilter:BOOLEAN;
        ColumAttr:ColumToSuffixArray;
        DispState:DispStateEnum;
        constructor Create(hWndCont:HWnd;KD:KrXMLDocClass);
        FUNCTION  AllocRow(RowSize:INTEGER;PageNode:TDOMNode):pRowInfo;
        FUNCTION SetRow(pRow:pRowInfo;node:TDOMNode):pRowInfo;
        FUNCTION GetRowInfoSize:LONGINT;
        PROCEDURE FlushColum;
        PROCEDURE ReSetColum(pfiCur:pFieldInfo);
        PROCEDURE SetColum;
        PROCEDURE SetStyle(style:ULong);
        PROCEDURE InsertNewRecord;
        PROCEDURE DeleteRecord;
        PROCEDURE CopyRecord(pRowOrg:pRowInfo);
        PROCEDURE MoveRecord(pRowOrg:pRowInfo);
        PROCEDURE GetRowList;
        PROCEDURE FlushRowList;
        FUNCTION GetRowListCount:INTEGER;
        FUNCTION GetRowByIndex(i:INTEGER):pRowInfo;
        FUNCTION isData:BOOLEAN;
        PROCEDURE SetIsData(b:BOOLEAN);
        FUNCTION isColum:BOOLEAN;
        FUNCTION GetHWnd:hwnd;
      PRIVATE
        isDataExist:BOOLEAN;
        isColumExist:BOOLEAN;
        hwndCntr:hwnd;
        RowList:TList;
    END;

    KrPageManegerClass=CLASS
        DataDoc:krXMLDocClass;
        hwndNB:hwnd;
        FrameWindow:hwnd;
        hwndConMenu:hwnd;
        ContainerList:TList;
        MaxColum:INTEGER;
        constructor Create(hwndNoteBook:hwnd);
        PROCEDURE DeletePage;
        PROCEDURE FlushAllPage;
        PROCEDURE CreateBlankPage(nbClient:CellDef);
        FUNCTION SetPageFromNode(node:TDOMNode):TDOMNode;
        FUNCTION GetContainer(id:ULong):ContainerClass;
        FUNCTION GetTopPageContainer:ContainerClass;
        FUNCTION LoadData(FN:String;nbClient:CellDef):BOOLEAN;
        FUNCTION ImportData(FN:String;nbClient:CellDef):BOOLEAN;
        PROCEDURE CnrToDoc;
        PROCEDURE SaveFile;
        PROCEDURE ExportFile;
        FUNCTION GetCurCntr:ContainerClass;
        PROCEDURE SetAnchor(An:HAB);
        PROCEDURE CopyClip(pCh:pChar);
        PROCEDURE InsertPageMenu(suffix:ULong);
        PROCEDURE FlushPageMenu;
        PROCEDURE CreatePageMenu;
        PROCEDURE RenamePageMenu(suffix:INTEGER;st:string);
        PROCEDURE SetDocName(st:string);
        FUNCTION isData:BOOLEAN;
        PROCEDURE LoadMsg;
        PROCEDURE RunExec(RunSt,ArgSt:String);
        PROCEDURE FlushSave;
      PRIVATE
//        isSetupCrypt:BOOLEAN;
        NoteClient:CellDef;
        CntClass:ContainerClass;
        Anchor:HAB;
    END;

FUNCTION isBlankpCh(p1:pChar):BOOLEAN;

FUNCTION AllocStrCopy(p1,p2:pChar):pChar;

FUNCTION AllocStrPCopy(p1:pChar;s:string):pChar;

FUNCTION pChToHPointer(pCh:pChar;VAR hptrIcon:HPointer):BOOLEAN;

PROCEDURE ActiveMenu(hwndFrame:hwnd;ID_ParentMenu,id:ULONG;Active:BOOLEAN);
PROCEDURE InsertSubMenu(hwndFrame:hWnd;
                        ID_ParentMenu,ID_InsertMenu:INTEGER;
                        MenuName:String);
PROCEDURE RenameMenu(FrameWindow:hWnd;
                    ID_PARENT,ID_Menu:INTEGER;
                    MenuName:string);

PROCEDURE DeleteMenu(FrameWindow:hWnd;
                      ID_Parent,ID_Menu:INTEGER);

IMPLEMENTATION
CONST
    WinTitle='KeyRingMini';

FUNCTION isBlankpCh(p1:pChar):BOOLEAN;
BEGIN
    IF (p1=NIL) OR
       (StrComp(p1,'')=0) OR
       (StrComp(p1,' ')=0) THEN
    BEGIN
        result:=TRUE;
    END
    ELSE
        result:=FALSE;
END;

FUNCTION AllocStrCopy(p1,p2:pChar):pChar;
BEGIN
    IF p2=NIL THEN BEGIN
        p1:=NIL;
        result:=p1;
        EXIT;
    END;
    IF StrComp(p2,'')=0 THEN BEGIN
        p1:=StrCopy(p2,'');
        result:=p1;
        EXIT;
    END;
    IF p1<>NIL THEN FreeMem(p1,StrLen(p1));
    GetMem(p1,StrLen(p2)+1);
    result:=StrCopy(p1,p2);
END;

FUNCTION AllocStrPCopy(p1:pChar;s:string):pChar;
BEGIN
    IF s='' THEN BEGIN
        p1:=NIL;
        result:=p1;
        EXIT;
    END;
    IF p1<>NIL THEN
        FreeMem(p1,StrLen(p1));
    GetMem(p1,Length(s)+1);
    s:=s+#0;
    result:=StrCopy(p1,@s[1]);
END;

FUNCTION pChToHPointer(pCh:pChar;VAR hptrIcon:HPointer):BOOLEAN;
VAR
    i:INTEGER;
BEGIN
    IF (pCh<>NIL ) AND  (StrPos(StrUpper(pCh),'.ICO')<>NIL) THEN BEGIN
        hptrIcon:=WinLoadFileIcon(pCh,FALSE);
        IF hptrIcon=NullHandle THEN BEGIN
            result:=FALSE;
            hptrIcon:=WinLoadPointer(HWND_DESKTOP,NULLHANDLE,ICO_ITEM);
        END
        ELSE BEGIN
            result:=TRUE;
        END;
    END
    ELSE BEGIN
        hptrIcon:=WinLoadPointer(HWND_DESKTOP,NULLHANDLE,ICO_ITEM);
        result:=FALSE;
    END;
END;
FUNCTION FileToXML(isKeyword:BOOLEAN;
                   key:string;
                   AStream:TFileStream):TXMLDocument;
VAR
    DOC:TXMLDocument;
    Buf:ARRAY[1..5] OF CHAR;
BEGIN
    IF isKeyword THEN BEGIN
        FileToXML:=CryptFileToXML(AStream,key);
    END
    ELSE BEGIN
        AStream.position:=0;
        AStream.ReadBuffer(Buf,SizeOf(Buf));
        IF (Buf[1]<>'<') OR (Buf[2]<>'?') OR (Buf[3]<>'x') OR
           (Buf[4]<>'m') OR (Buf[5]<>'l') THEN BEGIN
            result:=NIL;
            EXIT;
        END;
        AStream.position:=0;
        ReadXMLFileStream(DOC,TStream(AStream));
        IF Doc=NIL THEN BEGIN
            result:=NIL;
            AStream.Free;
            EXIT;
        END;
        FileToXML:=Doc;
        AStream.Free;
    END;
END;

PROCEDURE XMLToFile(isKeyword:BOOLEAN;
                    key:string;
                    AStream:TFileStream;
                    DOC:TXMLDocument);
BEGIN
    IF isKeyword THEN
        XMLToCryptFile(AStream,Key,doc)
    ELSE BEGIN
        WriteXMLFileStream(DOC,TStream(AStream));
        AStream.Free;
    END;
END;



constructor KrXMLDocClass.Create;
VAR
   i:INTEGER;
BEGIN
    MaxColumNumber:=9;
    DocFileName:='';
    Doc:=NIL;
    isUseCrypt:=FALSE;
END;

FUNCTION KrXMLDocClass.isKrDoc(FN:String):BOOLEAN;
VAR
    node:TDOMNode;
    AStream:TFileStream;
BEGIN
  try
    AStream:=TFileStream.Create(FN,fmOpenRead);
  except
    WinMessageBox(HWND_DESKTOP,ErrorMsgWnd,
              @pChLoadError,
              'Error Message',
              0,
              MB_CANCEL OR MB_ERROR);
    EXIT;
  END;
    isKrDoc:=FALSE;
    DocFileName:=FN;
    Doc:=FileToXML(isUseCrypt,password,AStream);
    IF Doc=NIL THEN BEGIN
        EXIT;
    END;
    node:=Doc.DocumentElement;
    IF (Node.NodeName<>MainPath) THEN BEGIN
        isKrDoc:=FALSE;
        Doc.Destroy;
        Doc:=NIL;
        EXIT;
    END;
    isKrDoc:=TRUE;
END;

FUNCTION KrXMLDocClass.GetMaxColum:INTEGER;
BEGIN
    GetMaxColum:=MaxColumNumber;
END;

FUNCTION KrXMLDocClass.GetFirstPage:TDOMNode;
BEGIN
    result:=Doc.DocumentElement.FindNode(GroupPath);
END;

FUNCTION KrXMLDocClass.GetMaxPage:INTEGER;
VAR
    node:TDOMNode;
    i:INTEGER;
BEGIN
    node:=GetFirstPage;
    WHILE node<>NIL DO BEGIN
        i:=i+1;
        node:=Node.NextSibling;
    END;
    result:=i;
END;

FUNCTION KrXMLDocClass.GetMaxPageNode(GroupNode:TDOMNode):INTEGER;
VAR
    i:INTEGER;
    node:TDOMNode;
BEGIN
    i:=0;
    IF GroupNode=NIL THEN BEGIN
        result:=1;
    END
    ELSE BEGIN
        node:=GroupNode.FindNode(ItemPath);
        WHILE Node<>NIL DO BEGIN
            i:=i+1;
            node:=Node.NextSibling;
        END;
        result:=i;
    END;
END;

PROCEDURE KrXMLDocCLass.FlushXMLData;
VAR
    PrevNode,CurNode,ParentNode:TDOMNode;
    st:string;
BEGIN
    Doc.Destroy;
    Doc:=NIL;
END;

FUNCTION KrXMLDocCLass.CreatePageData(PageName,PageInfoSt:String):TDOMNode;
VAR
    PageNode:TDOMElement;
    wNode:TDOMNode;
BEGIN
    PageNode:=Doc.CreateElement(GroupPath);
    PageNode.SetAttribute(GroupNameAttr,PageName);
    PageNode.SetAttribute(GroupInfoAttr,PageInfoSt);
    wNode:=Doc.FindNode(MainPath);
    wNode.AppendChild(PageNode);
    result:=TDOMNode(PageNode);
END;

FUNCTION KrXMLDocCLass.CreatePageItemData(PageNode:TDOMNode;N:String):TDOMElement;
VAR
    Node:TDOMElement;
BEGIN
    Node:=Doc.CreateElement(N);
    PageNode.AppendChild(Node);
    result:=Node;
END;

PROCEDURE KrXMLDocClass.SetNodeAttr(Node:TDOMElement;suffix:INTEGER;pRow:pRowInfo);
VAR
    NameStr,AttrStr:AnsiString;
BEGIN
    CASE Suffix OF
        1:BEGIN
            AttrStr:=StrPas(pRow^.pChAry[1]);
        END;
        2:AttrStr:=StrPas(pRow^.Core.pszIcon);
        ELSE
            AttrStr:=StrPas(pRow^.pChAry[Suffix]);
    END;
    NameStr:=ColumAttrList[Suffix];
    WHILE (Length(AttrStr)>0) AND (AttrStr[length(AttrStr)]<#33) DO
        System.Delete(AttrStr,Length(AttrStr),1);
    IF (AttrStr<>'') AND (AttrStr<>' ') THEN BEGIN
        Node.SetAttribute(NameStr,AttrStr);
    END;

END;

PROCEDURE KrXMLDocClass.SetFileName(st:string);
BEGIN
    IF Assigned(Doc)=FALSE THEN BEGIN
        MakeNewDoc;
    END;
    DocFileName:=St;
END;

FUNCTION KrXMLDocClass.GetFileName:String;
BEGIN
    result:=DocFileName;
END;


FUNCTION KrXMLDocClass.isDoc:BOOLEAN;
BEGIN
    IF DocFileName='' THEN BEGIN
        isDoc:=FALSE;
        EXIT;
    END
    ELSE
        isDoc:=TRUE;
    IF Doc=NIL THEN BEGIN
        MakeNewDoc;
    END;
END;

PROCEDURE KrXMLDocClass.MakeNewDoc;
BEGIN
    Doc:=TXMLDocument.Create;
    Doc.AppendChild(Doc.CreateElement(MainPath));
END;

PROCEDURE KrXMLDocClass.SaveDoc;
VAR
    bakFileName:string;
    i:INTEGER;
    AStream:TFileStream;
    PROCEDURE StoreFile(FN:string;Gen:INTEGER);
    VAR
        wSt1,wSt2:string;
        rc:BOOLEAN;
        f:file;
    BEGIN
        IF gen=0 THEN
            wSt1:=DocFileName
        ELSE
            wSt1:=FN+'.BK'+IntToStr(Gen);
        IF FIleExists(wSt1) THEN BEGIN
            wSt2:=FN+'.BK'+IntToStr(Gen+1);
            wSt1:=ExpandFileName(wSt1);
            wSt2:=ExpandFileName(wSt2);
            rc:=RenameFile(wSt1,wSt2);
        END;
    END;
BEGIN
    IF DocFileName<>'' THEN BEGIN
        IF FileExists(DocFileName) THEN BEGIN
            BakFileName:=DocFileName;
            System.Delete(
                BakFileName,
                Length(BakFileName)-Length(ExtractFileExt(BakFileName))+1,
                Length(ExtractFileExt(BakFileName)) );
            FOR i:=3 downto 0 DO BEGIN
                StoreFile(BakFileName,i);
            END;
        END;
      try
        AStream:=TFileStream.Create(DocFileName,fmCreate);
      except
        WinMessageBox(HWND_DESKTOP,ErrorMsgWnd,
                      @pChSaveError,
                      'Error Message',
                      0,
                      MB_CANCEL OR MB_ERROR);
        AStream:=TFileStream.Create('NOW-WORK',fmCreate);
      END;
        XMLToFile(isUseCrypt,password,AStream,Doc)
    END
    ELSE BEGIN
        AStream:=TFileStream.Create('NOW-WORK',fmCreate);
        XMLToFile(isUseCrypt,password,AStream,doc);
    END;
END;

constructor ContainerClass.Create(hWndCont:HWnd;KD:KrXMLDocClass);
VAR
    i:INTEGER;
BEGIN
    hwndCntr:=hwndCont;
    KrDoc:=KD;
    SetIsData(FALSE);
    isColumExist:=FALSE;
    isFilter:=FALSE;
    AppName:='';
    ColumAttr:=DefaultColumToSuffix;
    DispState:=normal;
END;


FUNCTION ContainerClass.SetRow(pRow:pRowInfo;Node:TDOMNode):pRowInfo;
VAR
    St,wSt: String;
    i:INTEGER;
    hptrIcon:HPointer;
    FUNCTION GetColumStr(AtSt:string):string;
    VAR
        rSt:string;
    BEGIN
        IF node=NIL THEN
            result:=''
        ELSE BEGIN
            rSt:=TDOMElement(Node).GetAttribute(AtSt);
            result:=rSt;
        END;
    END;
BEGIN
    pRow^.Core.cb := sizeof(RowInfoRecord);

    St:=ColumAttrList[2];
    St:=GetColumStr(st);
    IF St='' THEN
        pRow^.Core.pszIcon:=AllocStrPCopy(pRow^.Core.pszIcon,BlankStr)
    ELSE
        pRow^.Core.pszIcon:=AllocStrPCopy( pRow^.Core.pszIcon,St);
    pRow^.Core.pszText:=NIL;
    pRow^.Core.pszName:=NIL;
    pRow^.pChHide:=pHideConst;

    St:=ColumAttrList[1];
    St:=GetColumStr(St);
    IF st='' THEN
        pRow^.Core.hptrIcon := WinLoadPointer(HWND_DESKTOP,
                                          NULLHANDLE,
                                          ICO_ITEM)
    ELSE BEGIN
        wSt:=St+#0;
        IF pChToHPointer(@wSt[1],hptrIcon) THEN BEGIN
            pRow^.Core.hptrIcon:=hptrIcon;
            pRow^.pChAry[1]:=AllocStrPCopy(pRow^.pChAry[1],St);
        END
        ELSE BEGIN
            pRow^.Core.hptrIcon := WinLoadPointer(HWND_DESKTOP,
                                                  NULLHANDLE,
                                                  ICO_ITEM);
            pRow^.pChAry[1]:=NIL;
        END;

    END;
    FOR i:=3 TO MaxColumList DO BEGIN
        St:=ColumAttrList[i];
        St:=GetColumStr(St);
        IF i<8 THEN BEGIN
            IF St='' THEN St:=BlankStr;
        END
        ELSE BEGIN
            IF St='' THEN St:=DateToStr(Now);
        END;
        pRow^.pChAry[i]:=AllocStrPCopy( pRow^.pChAry[i], St);
    END;
    St:=GetColumStr(ExpireCheckConst);
    IF UpperCase(St)<>'FALSE' THEN
        pRow^.isExpireCheck:=TRUE
    ELSE
        pRow^.isExpireCheck:=FALSE;
END;

FUNCTION ContainerClass.AllocRow(RowSize:INTEGER;PageNode:TDOMNode):pRowInfo;
VAR
    pRow,pCurRow:pRowInfo;
    riRecord  : RECORDINSERT;
    node:TDOMNode;
    i,j,k:INTEGER;
    st,st2:string;
BEGIN
    SetIsData(TRUE);
    pRow :=
      pRowInfo(
        PVOIDFROMMR(
          WinSendMsg(hwndCntr,
                     CM_ALLOCRECORD,
                     MPFROMLONG(GetRowInfoSize),
                     MPFROMSHORT(RowSize) )));
    AllocRow:=pRow;
    riRecord.cb := sizeof(RECORDINSERT);
    riRecord.pRecordOrder := PRECORDCORE(CMA_END);
    riRecord.fInvalidateRecord := ord(FALSE);
    riRecord.zOrder := CMA_TOP;
    riRecord.pRecordParent := NIL;
    riRecord.cRecordsInsert := 1;


    pCurRow:=pRow;
    IF PageNode=NIL THEN BEGIN
        SetRow(pCurRow,NIL);
        WinSendMsg(hwndCntr,
                   CM_INSERTRECORD,
                   MPFROMP(pCurRow),
                   MPFROMP(@riRecord));
    END
    ELSE BEGIN
        Node:=PageNode.FindNode(GroupStylePath);
        IF node<>NIL THEN BEGIN
             AppName:=TDOMElement(node).GetAttribute(AppNameAttr);
        END;
        Node:=Node.FindNode(ColumStyle);
        IF Node <>NIL THEN
            Node:=Node.FindNode(ColumItem);
        IF node<>NIL THEN BEGIN
            FOR i:=3 TO MaxColumList DO BEGIN
                St:=TDOMElement(node).GetAttribute(ColumName);
                FOR j:=3 TO MaxColumList DO BEGIN
                    St2:=ColumAttrList[j];
                    IF St= St2 THEN BEGIN
                        Break;
                    END;
                END;
                St:=TDOMElement(node).GetAttribute(ColumOrder);
                k:=StrToInt(st);
                ColumAttr[k].ix:=j;

                St:=TDOMElement(node).GetAttribute(ColumDisp);
                IF UpperCase(st)='TRUE' THEN
                    ColumAttr[k].isDisp:=TRUE
                ELSE
                    ColumAttr[k].isDisp:=FALSE;
                node:=Node.NextSibling;
            END;
        END;

        Node:=PageNode.FindNode(ItemPath);
        WHILE Node<>NIL DO BEGIN
            SetRow(pCurRow,node);
            WinSendMsg(hwndCntr,
                       CM_INSERTRECORD,
                       MPFROMP(pCurRow),
                       MPFROMP(@riRecord));
            pCurRow := pRowInfo( pCurRow^.Core.preccNextRecord );
            node:=Node.NextSibling;
        END;
    END;
END;

FUNCTION ContainerClass.GetRowInfoSize:LONGINT;
BEGIN
    result:=SizeOf(RowInfoRecord)-SizeOf(RecordCore);
END;

PROCEDURE ContainerClass.FlushColum;
VAR
    ciInfo       : CNRINFO;
    pfiCur   : PFIELDINFO;
    pfiInfo      : PFIELDINFO;
    pfiLefty     : PFIELDINFO;
    fiiInfo      : FIELDINFOINSERT;
    rc:INTEGER;
BEGIN
    pfiInfo:=pFieldInfo(WinSendMsg( hwndCntr,
                                    CM_QUERYDETAILFIELDINFO,
                                    MPFROMP(pfiInfo),
                                    CMA_FIRST));
    pfiCur := pfiInfo;
    IF pfiCur=NIL THEN EXIT;

    pfiCur^.flData := CFA_BITMAPORICON OR ulColumStyle;

    pfiCur^.flTitle := ulTitleStyle;
    pfiCur^.pTitleData := ColumList[1];
    pfiCur^.offStruct := ofs( pRowInfo(NIL)^.Core.hptrIcon );
    pfiCur := pfiCur^.pNextFieldInfo;
    pfiCur^.flData := CFA_STRING OR CFA_LEFT OR CFA_HORZSEPARATOR;

    pfiCur^.flTitle := ulTitleStyle;
    pfiCur^.pTitleData := ColumList[2];
    pfiCur^.offStruct := ofs( pRowInfo(NIL)^.Core.pszIcon );

    pfiLefty := pfiCur;
    ReSetColum(pfiCur);

    fiiInfo.cb := sizeof(fiiInfo);
    fiiInfo.pFieldInfoOrder := pFIELDINFO(CMA_FIRST);
    fiiInfo.cFieldInfoInsert := KrDoc.GetMaxColum;
    fiiInfo.fInvalidateFieldInfo := ord(TRUE);

    rc:=WinSendMsg( hwndCntr,CM_INVALIDATEDETAILFIELDINFO,0,0);

    ciInfo.cb := sizeof(CNRINFO);
    ciInfo.pFieldInfoLast := pfiLefty;
    ciInfo.xVertSplitbar := CX_SPLITBAR;

    WinSendMsg(hwndCntr,
               CM_SETCNRINFO,
               MPFROMP(@ciInfo),
               MPFROMLONG(CMA_PFIELDINFOLAST OR CMA_XVERTSPLITBAR));
    isColumExist:=TRUE;
END;

PROCEDURE ContainerClass.ReSetColum(pfiCur:pFieldInfo);
VAR
    i:INTEGER;
BEGIN
    FOR i:=3 TO KrDoc.GetMaxColum DO BEGIN
        pfiCur := pfiCur^.pNextFieldInfo;
        IF ColumAttr[i].isDisp THEN BEGIN
            pfiCur^.flData := CFA_STRING OR CFA_LEFT OR
                                  CFA_HORZSEPARATOR OR CFA_SEPARATOR;
            IF ColumAttr[i].ix>7 THEN
                pfiCur^.flData:=pfiCur^.flData OR CFA_FiReadOnly;
            pfiCur^.flTitle := ulTitleStyle;
            pfiCur^.pTitleData := ColumList[ColumAttr[i].ix];
            pfiCur^.offStruct:= ofs(pRowInfo(NIL)^.pChAry[ColumAttr[i].ix]);
            IF ColumAttr[i].ix=4 THEN BEGIN
                CASE DispState OF
                    hide:BEGIN
                            pfiCur^.offStruct:=ofs(pRowInfo(NIL)^.pChHide);
                            pfiCur^.flData:=pfiCur^.flData OR CFA_FIReadOnly;
                    END;
                    nodisp:BEGIN
                            pfiCur^.flData:=pfiCur^.flData OR CFA_INVISIBLE;
                    END;
                END;
            END;
        END;
    END;
END;

PROCEDURE ContainerClass.SetColum;
VAR
    ciInfo       : CNRINFO;
    pfiCur   : PFIELDINFO;
    pfiInfo      : PFIELDINFO;
    pfiLefty     : PFIELDINFO;
    fiiInfo      : FIELDINFOINSERT;
    rc:INTEGER;
BEGIN
    pfiInfo:=PFIELDINFO(WinSendMsg( hwndCntr,
                                    CM_ALLOCDETAILFIELDINFO,
                                    MPFROMLONG(KrDoc.GetMaxColum),0));

    pfiCur := pfiInfo;

    pfiCur^.flData := CFA_BITMAPORICON OR ulColumStyle;

    pfiCur^.flTitle := ulTitleStyle;
    pfiCur^.pTitleData := ColumList[1];
    pfiCur^.offStruct := ofs( pRowInfo(NIL)^.Core.hptrIcon );
    pfiCur := pfiCur^.pNextFieldInfo;
    pfiCur^.flData := CFA_STRING OR CFA_LEFT OR CFA_HORZSEPARATOR;

    pfiCur^.flTitle := ulTitleStyle;
    pfiCur^.pTitleData := ColumList[2];
    pfiCur^.offStruct := ofs( pRowInfo(NIL)^.Core.pszIcon );

    pfiLefty := pfiCur;
    ReSetColum(pfiCur);

    fiiInfo.cb := sizeof(fiiInfo);
    fiiInfo.pFieldInfoOrder := pFIELDINFO(CMA_FIRST);
    fiiInfo.cFieldInfoInsert := KrDoc.GetMaxColum;
    fiiInfo.fInvalidateFieldInfo := ord(TRUE);

    rc:=WinSendMsg( hwndCntr,
                    CM_INSERTDETAILFIELDINFO,
                    MPFROMP(pfiInfo),
                    MPFROMP(@fiiInfo));

    ciInfo.cb := sizeof(CNRINFO);
    ciInfo.pFieldInfoLast := pfiLefty;
    ciInfo.xVertSplitbar := CX_SPLITBAR;

    WinSendMsg(hwndCntr,
               CM_SETCNRINFO,
               MPFROMP(@ciInfo),
               MPFROMLONG(CMA_PFIELDINFOLAST OR CMA_XVERTSPLITBAR));
    isColumExist:=TRUE;
END;

PROCEDURE ContainerClass.SetStyle(style:ULong);
VAR
    ciInfo    : CNRINFO;
BEGIN
    ciInfo.cb := sizeof(CNRINFO);
    ciInfo.flWindowAttr := style;

    WinSendMsg( hwndCntr,
                CM_SETCNRINFO,
                MPFROMP(@ciInfo),
                MPFROMLONG(CMA_FLWINDOWATTR));
    IF CV_ICON AND Style >0 THEN
            WinSendMsg( hwndCntr,CM_ARRANGE,0,0);
END;

PROCEDURE ContainerClass.InsertNewRecord;
VAR
    pRow:pRowInfo;
    Ri:RecordInsert;
    i:INTEGER;
BEGIN
    SetIsData(TRUE);
    pRow:=pRowInfo(WinSendMsg(hwndCntr,
                              CM_AllocRecord,
                              MPFROMLONG(GetRowInfoSize),
                              MPFROMSHORT(1)));
    pRow^.pChHide:=pHideConst;
    pRow^.Core.cb := sizeof(RowInfoRecord);

    pRow^.Core.pszIcon:=AllocStrPCopy( pRow^.Core.pszIcon,'New Record');
    pRow^.Core.hptrIcon := WinLoadPointer(HWND_DESKTOP,
                                          NULLHANDLE,
                                          ICO_ITEM);
    pRow^.pChAry[1]:=AllocStrCopy(pRow^.pChAry[1],' ');
    FOR i:=1 TO MaxColumList-2 DO BEGIN
        pRow^.pChAry[i]:=AllocStrCopy(pRow^.pChAry[i],'New');
    END;
    FOR i:=MaxColumList-1 TO MaxColumList DO BEGIN
        pRow^.pChAry[i]:=AllocStrPCopy(pRow^.pChAry[i],DateToStr(now));
    END;
    pRow^.isExpireCheck:=TRUE;
    ri.cb := sizeof(RECORDINSERT);
    ri.pRecordOrder := PRECORDCORE(CMA_END);
    ri.fInvalidateRecord := ord(TRUE);
    ri.zOrder := CMA_TOP;
    ri.pRecordParent := NIL;
    ri.cRecordsInsert := 1;
    WinSendMsg(hwndCntr,
               CM_InsertRecord,
               MPFROMP(pRow),
               MPFROMP(@ri));
END;

PROCEDURE ContainerClass.DeleteRecord;
VAR
    pRowRemove:pRowInfo;
    i,RemoveSuffix:INTEGER;
    riRecord:RecordInsert;
BEGIN
    pRowRemove:=pRowInfo(WinSendMsg(hwndCntr,
                              CM_QueryRecordEmphasis,
                              CMA_FIRST,
                              MPFROMSHORT(CRA_SELECTED )));
    riRecord.cb := sizeof(RECORDINSERT);
    riRecord.pRecordOrder := PRECORDCORE(CMA_END);
    riRecord.fInvalidateRecord := ord(FALSE);
    riRecord.zOrder := CMA_TOP;
    riRecord.pRecordParent := NIL;
    riRecord.cRecordsInsert := 1;

    WinSendMsg(hwndCntr,
                CM_RemoveRecord,
                MPFROMP(@pRowRemove),
                MPFROM2SHORT(1,CMA_INVALIDATE) );


    WinSendMsg(hwndCntr,
               CM_INVALIDATERECORD,
               CMA_FIRST,
               MPFROM2SHORT(0,CMA_REPOSITION));
END;

PROCEDURE ContainerClass.CopyRecord(pRowOrg:pRowInfo);
VAR
    pRow:pRowInfo;
    Ri:RecordInsert;
    i:INTEGER;
BEGIN
    SetIsData(TRUE);
    pRow:=pRowInfo(WinSendMsg(hwndCntr,
                              CM_AllocRecord,
                              MPFROMLONG(GetRowInfoSize),
                              MPFROMSHORT(1)));
    pRow^.pChHide:=pHideConst;
    pRow^.Core.cb := sizeof(RowInfoRecord);

    pRow^.Core.pszIcon:=AllocStrCopy( pRow^.Core.pszIcon,pRowOrg^.Core.pszIcon);
    pRow^.Core.hptrIcon := pRowOrg^.Core.hptrIcon;
    FOR i:=1 TO MaxColumList DO BEGIN
        pRow^.pChAry[i]:=AllocStrCopy(pRow^.pChAry[i],pRowOrg^.pChAry[i]);
    END;
    pRow^.isExpireCheck:=pRowOrg^.isExpireCheck;
    ri.cb := sizeof(RECORDINSERT);
    ri.pRecordOrder := PRECORDCORE(CMA_END);
    ri.fInvalidateRecord := ord(TRUE);
    ri.zOrder := CMA_TOP;
    ri.pRecordParent := NIL;
    ri.cRecordsInsert := 1;
    WinSendMsg(hwndCntr,
               CM_InsertRecord,
               MPFROMP(pRow),
               MPFROMP(@ri));
END;

PROCEDURE ContainerClass.MoveRecord(pRowOrg:pRowInfo);
VAR
    pRow:pRowInfo;
    Ri:RecordInsert;
    i:INTEGER;
BEGIN
    SetIsData(TRUE);
    pRow:=pRowInfo(WinSendMsg(hwndCntr,
                              CM_AllocRecord,
                              MPFROMLONG(GetRowInfoSize),
                              MPFROMSHORT(1)));
    pRow^:=pRowOrg^;
    ri.cb := sizeof(RECORDINSERT);
    ri.pRecordOrder := PRECORDCORE(CMA_END);
    ri.fInvalidateRecord := ord(TRUE);
    ri.zOrder := CMA_TOP;
    ri.pRecordParent := NIL;
    ri.cRecordsInsert := 1;
    WinSendMsg(hwndCntr,
               CM_InsertRecord,
               MPFROMP(pRow),
               MPFROMP(@ri));
END;

PROCEDURE ContainerClass.FlushRowList;
BEGIN
    IF Assigned(RowList) THEN BEGIN
        RowList.Free;
        RowList:=NIL;
    END;
END;

PROCEDURE ContainerClass.GetRowList;
VAR
    pRow:pRowInfo;
BEGIN
    RowList:=TList.Create;
    pRow:=pRowInfo(WinSendMsg( hwndCntr,
                               CM_QUERYRECORD,
                                MPFROMP(NIL),
                                MPFROM2SHORT(CMA_FIRST,CMA_ITEMORDER)));
    WHILE pRow<>NIL DO BEGIN
        RowList.Add(pRow);
        pRow:=pRowInfo(
                WinSendMsg( hwndCntr,
                            CM_QUERYRECORD,
                            MPFROMP(pRow),
                            MPFROM2SHORT(CMA_NEXT,CMA_ITEMORDER)));
    END;
END;

FUNCTION ContainerClass.GetRowListCount:INTEGER;
BEGIN
    IF Assigned(RowList) THEN result:=RowList.Count ELSE result:=0;
END;

FUNCTION ContainerClass.GetRowByIndex(i:INTEGER):pRowInfo;
BEGIN
    IF Assigned(RowList) THEN
        result:=pRowInfo(RowList[i])
    ELSE
        result:=NIL;
END;

FUNCTION ContainerClass.isData:BOOLEAN;
BEGIN
    result:=isDataExist;
END;


PROCEDURE ContainerClass.SetIsData(b:BOOLEAN);
BEGIN
    isDataExist:=b;
END;

FUNCTION ContainerClass.isColum:BOOLEAN;
BEGIN
    result:=isColumExist;
END;

FUNCTION ContainerClass.GetHWnd:hwnd;
BEGIN
    result:=hwndCntr;
END;


constructor KrPageManegerClass.Create(hwndNotebook:hwnd);
BEGIN
    hwndNB:=hwndNotebook;
    ContainerList:=TList.Create;
    MaxColum:=0;
    DataDoc:=KrXMLDocClass.Create;
END;

PROCEDURE KrPageManegerClass.FlushAllPage;
VAR
    i:INTEGER;
    PageID:INTEGER;
    Cntr:ContainerClass;
BEGIN
    FOR i:=ContainerList.Count-1 downto 0 DO BEGIN
        Cntr:=ContainerClass(ContainerList[i]);
        Cntr.SetIsData(FALSE);
        PageID:=Cntr.id;
        WinSendMsg(hwndNb, BKM_SETPAGEWINDOWHWND, PageID, Cntr.GetHWnd);
        DeletePage;
    END;
END;

PROCEDURE KrPageManegerClass.DeletePage;
VAR
    CurPageID:ULong;
    DelNum,i:INTEGER;
    pRowRemove:pRowInfo;
    pfiInfo:pFieldInfo;
    Cntr:ContainerClass;
    pChTitle:pChar;
BEGIN
    FlushPageMenu;
    CurPageID:=WinSendMsg( hwndNB,
                           BKM_QUERYPAGEID,
                           CurPageID,
                           MPFROM2SHORT(BKA_TOP,BKA_MAJOR));
    FOR i:=0 TO ContainerList.Count-1 DO BEGIN
        IF ContainerClass(ContainerList[i]).id=CurPageID THEN BEGIN
            DelNum:=i;
        END;
    END;
    IF ContainerList.Count>1 THEN BEGIN
        WinSendMsg( hwndNB,
                    BKM_DELETEPAGE,
                    CurPageID,
                    BKA_SINGLE);
        ContainerList.Delete(DelNum);
    END
    ELSE BEGIN
        CreateBlankPage(NoteClient);
        FlushPageMenu;
        CurPageID:=WinSendMsg( hwndNB,
                               BKM_QUERYPAGEID,
                               CurPageID,
                               MPFROM2SHORT(BKA_FIRST,BKA_MAJOR));

        WinSendMsg( hwndNB,
                    BKM_DELETEPAGE,
                    CurPageID,
                    BKA_SINGLE);
        ContainerList.Delete(DelNum);

    END;
    CreatePageMenu;
END;

PROCEDURE KrPageManegerClass.CreateBlankPage(nbClient:CellDef);
VAR
    pChTitle:pChar;
    PageID:ULong;
    hwndPage:hwnd;
BEGIN
    PageID:=WinSendMsg( hwndNb,
                        BKM_INSERTPAGE,
                        0,
                        MPFROM2SHORT(BKA_MAJOR OR
                                     BKA_AUTOPAGESIZE OR
                                     BKA_STATUSTEXTON,      BKA_LAST));
    hwndPage:=CreateCell(nbClient,hwndNb,hwndNb);
    CntClass:=ContainerClass.Create(WinWindowFromID(hwndPage,ID_CONTAINER),
                                    DataDoc);//
    CntClass.id:=PageID;
    GetMem(pChTitle,MaxCharLength);
    pChTitle:='Blank';
    WinSendMsg(hwndNb, BKM_SETTABTEXT, PageID, LONG(pChTitle));
    WinSendMsg(hwndNB, BKM_SETSTATUSLINETEXT,PageID,LONG(pChTitle));
    CntClass.GroupName:=StrPas(pChTitle);
    CntClass.GroupInfoStr:=StrPas(pChTitle);

    MaxColum:=CntClass.KrDoc.GetMaxColum;
    CntClass.SetStyle(  CV_DETAIL OR
                        CA_DETAILSVIEWTITLES
                        OR cv_mini);
    ContainerList.Add(CntClass);

    WinSendMsg(hwndNb, BKM_SETPAGEWINDOWHWND, PageID, hwndPage);
    InsertPageMenu(ContainerList.Count-1);
    NoteClient:=nbClient;
END;

FUNCTION KrPageManegerClass.SetPageFromNode(node:TDOMNode):TDOMNode;
VAR
    pChTitle:pChar;
    st:string;
    rc:ulong;
BEGIN
    IF node=NIL THEN BEGIN
        result:=NIL; EXIT;
    END;
    CntClass.AllocRow(DataDoc.GetMaxPageNode(node),node);
    GetMem(pChTitle,MaxCharLength);
    st:=TDOMElement(Node).GetAttribute(GroupNameAttr);
    CntClass.GroupName:=st;
    StrPCopy(pChTitle,st);
    WinSendMsg(hwndNb, BKM_SETTABTEXT, CntClass.id, LONG(pChTitle));
    st:=TDOMElement(Node).GetAttribute(GroupInfoAttr);
    CntClass.GroupInfoStr:=st;
    IF St<>'' THEN
        StrPCopy(pChTitle,st);
    rc:=WinSendMsg(hwndNb, BKM_SETSTATUSLINETEXT, CntClass.id, LONG(pChTitle));

    CntClass.SetColum;
    MaxColum:=CntClass.KrDoc.GetMaxColum;
    CntClass.SetStyle(  CV_DETAIL OR
                        CA_DETAILSVIEWTITLES
                        OR cv_mini);
    result:=node.NextSibling;
    RenamePageMenu(ContainerList.Count-1,CntClass.GroupName);
END;

FUNCTION KrPageManegerClass.GetContainer(id:ULong):ContainerClass;
VAR
    i:INTEGER;
BEGIN
    FOR i:=0 TO ContainerList.Count-1 DO BEGIN
        IF ContainerClass(ContainerList[i]).id=id THEN BEGIN
            result:=ContainerClass(ContainerList[i]);
            EXIT;
        END;
    END;
    result:=NIL
END;

FUNCTION KrPageManegerClass.GetTopPageContainer:ContainerClass;
VAR
    CurPageID:ULong;
BEGIN
    CurPageID:=WinSendMsg( hwndNB,
                           BKM_QUERYPAGEID,
                           CurPageID,
                           MPFROM2SHORT(BKA_TOP,BKA_MAJOR));
    result:=GetContainer(CurPageID);
END;

PROCEDURE KrPageManegerClass.CnrToDoc;
VAR
    pRow:pRowInfo;
    Cntr:ContainerClass;
    i,ii,j,k:INTEGER;
    MaxPage:INTEGER;
    node:TDOMNode;
    ItemNode,ColumNode:TDOMElement;
    St:string;
BEGIN
    MaxPage:=ContainerList.Count;
    FOR i:=0 TO MaxPage-1 DO BEGIN
        Cntr:=ContainerClass(ContainerList[i]);
        IF Cntr.isData THEN BEGIN
            Node:=DataDoc.CreatePageData(Cntr.GroupName,Cntr.GroupInfoStr);
            ItemNode:=DataDoc.CreatePageItemData(node,GroupStylePath);
            ItemNode.SetAttribute(AppNameAttr,Cntr.AppName);

            ItemNode:=DataDoc.CreatePageItemData(ItemNode,ColumStyle);
            FOR j:=3 TO MaxColumList DO BEGIN
                ColumNode:=DataDoc.CreatePageItemData(ItemNode,ColumItem);
                St:=ColumAttrList[Cntr.ColumAttr[j].ix];
                ColumNode.SetAttribute(ColumName,St);
                ColumNode.SetAttribute(ColumOrder,IntToStr(j));
                IF Cntr.ColumAttr[j].isDisp THEN
                    ColumNode.SetAttribute(ColumDisp,'TRUE')
                ELSE
                    ColumNode.SetAttribute(ColumDisp,'FALSE');
            END;
            Cntr.GetRowList;
            FOR ii:=0 TO Cntr.GetRowListCount-1 DO BEGIN
                pRow:=Cntr.GetRowByIndex(ii);
                ItemNode:=DataDoc.CreatePageItemData(node,ItemPath);
                FOR j:=1 TO MaxColum DO
                    DataDoc.SetNodeAttr(ItemNode,j,pRow);
                IF pRow^.isExpireCheck =FALSE THEN BEGIN
                    ItemNode.SetAttribute(ExpireCheckConst,'FALSE');
                END;
            END;
            Cntr.FlushRowList;
        END;
    END;
END;

FUNCTION KrPageManegerClass.LoadData(FN:string;nbClient:CellDef):BOOLEAN;
VAR
    node:TDOMNode;
BEGIN
    IF DataDoc.isKrDoc(FN) THEN BEGIN
        SetDocName(FN);
        IF GetTopPageContainer.isData THEN
            CreateBlankPage(nbClient);
        node:=DataDoc.GetFirstPage;
        WHILE node<>NIL DO BEGIN
            node:=SetPageFromNode(node);
            IF node<>NIL THEN CreateBlankPage(nbClient);
        END;
        DataDoc.FlushXMLData;
        LoadData:=TRUE;
    END
    ELSE
        LoadData:=FALSE;
END;

FUNCTION KrPageManegerClass.ImportData(FN:String;nbClient:CellDef):BOOLEAN;
VAR
    OrgCrypt:BOOLEAN;
BEGIN
    OrgCrypt:=DataDoc.isUseCrypt;
    DataDoc.isUseCrypt:=FALSE;
    LoadData(FN,nbClient);
    DataDoc.isUseCrypt:=OrgCrypt;
END;

PROCEDURE KrPageManegerClass.SaveFile;
BEGIN
    IF isData THEN
        DataDoc.SaveDoc;
END;

PROCEDURE KrPageManegerClass.ExportFile;
VAR
    OrgCrypt:BOOLEAN;
BEGIN
    OrgCrypt:=DataDoc.isUseCrypt;
    DataDoc.isUseCrypt:=FALSE;
    DataDoc.SaveDoc;
    DataDoc.isUseCrypt:=OrgCrypt;
END;

PROCEDURE KrPageManegerClass.SetAnchor(An:HAB);
BEGIN
    Anchor:=An;
END;

FUNCTION KrPageManegerClass.GetCurCntr:ContainerClass;
VAR
    CurPageID:ULong;
BEGIN
    result:=GetContainer(WinSendMsg(hwndNB,
                                    BKM_QUERYPAGEID,
                                    CurPageID,
                                    MPFROM2SHORT(BKA_TOP,BKA_MAJOR)));
END;

PROCEDURE KrPageManegerClass.InsertPageMenu(suffix:ULong);
VAR
    St:string;
    Cntr:ContainerClass;
BEGIN
    Cntr:=ContainerClass(ContainerList[suffix]);
    IF Assigned(Cntr)=FALSE THEN EXIT;
    St:=Cntr.GroupName;
        InsertSubMenu(WinWindowFromID(FrameWindow,FID_MENU),
                      ID_CopyRecord,
                      ID_CopyTo+suffix,
                      St);
        InsertSubMenu(WinWindowFromID(FrameWindow,FID_MENU),
                      ID_MoveRecord,
                      ID_MoveTo+suffix,
                      St);
END;

PROCEDURE KrPageManegerClass.FlushPageMenu;
VAR
    i,j:INTEGER;
BEGIN
    j:=ContainerList.Count-1;
    IF j<0 THEN
        j:=0;
    FOR i:=j downto 0 DO BEGIN
        DeleteMenu(WinWindowFromID(FrameWindow,FID_MENU),
                   ID_MoveRecord,
                   MoveToIndex+i);
        DeleteMenu(WinWindowFromID(FrameWindow,FID_MENU),
                   ID_CopyRecord,
                   CopyToIndex+i);
    END;
END;
PROCEDURE KrPageManegerClass.CreatePageMenu;
VAR
    i:INTEGER;
BEGIN
    FOR i:=0 TO ContainerList.Count-1 DO BEGIN
        InsertPageMenu(i);
    END;
END;

PROCEDURE KrPageManegerClass.RenamePageMenu(Suffix:INTEGER;st:string);
BEGIN
    RenameMenu( WinWindowFromID(FrameWindow,FID_MENU),
                ID_CopyRecord,
                ID_CopyTo+Suffix,
                St);
    RenameMenu( WinWindowFromID(FrameWindow,FID_MENU),
                ID_MoveRecord,
                ID_MoveTo+Suffix,
                St);
END;

PROCEDURE KrPageManegerClass.SetDocName(st:string);
BEGIN
    DataDoc.SetFileName(st);
    St:=WinTitle+'-----'+St+#0;
    WinSetWindowText(FrameWindow,@St[1]);
END;

FUNCTION KrPageManegerClass.isData:BOOLEAN;
VAR
    i:INTEGER;
BEGIN
    FOR i:=0 TO ContainerList.Count-1 DO BEGIN
        IF ContainerClass(ContainerList[i]).isDataExist THEN BEGIN
            isData:=TRUE;
            EXIT;
        END;
    END;
    isData:=FALSE;
END;

PROCEDURE KrPageManegerClass.LoadMsg;
VAR
    rc:INTEGER;
BEGIN
    rc:=WinLoadMessage(Anchor,0,1500,ErrorMsgLength,@pChLoadError);
    rc:=WinLoadMessage(Anchor,0,1501,ErrorMsgLength,@pChSaveError);
END;

PROCEDURE KrPageManegerClass.RunExec(RunSt,ArgSt:String);
VAR
    PathSt,ExeSt,CurDir:string;
BEGIN
    IF RunSt='' THEN EXIT;
    PathSt:=ExtractFilePath(RunSt);
    IF PathSt[length(PathSt)]='\' THEN BEGIN
        System.Delete(PathSt,Length(PathSt),1);
    END;
    ExeSt:=ExtractFileName(RunSt);//
    GetDir(0,CurDir);
    ChDir(PathSt);
    ExecFlags := efAsync;
    Exec(ExeSt,ArgSt);
    ChDir(CurDir);
END;

PROCEDURE KrPageManegerClass.FlushSave;
BEGIN
    IF DataDoc.isDoc THEN BEGIN
         CnrToDoc;
         SaveFile;
         DataDoc.FlushXMLData;
    END;
END;

PROCEDURE KrPageManegerClass.CopyClip(pCh:pChar);
VAR
    rc:INTEGER;
    cCh:pChar;
    b:bool;
BEGIN
    IF WinOpenClipbrd(Anchor) THEN BEGIN
         // eLXgEf[^ɋp[EIuWFNgUB
        rc:=DosAllocSharedMem(
                 POINTER(cCh),//p[EIuWFNgw|C^[
                 NIL,//       OȂp[gp
                 StrLen(pCh)+1,//* U郁[̗
                 PAG_WRITE  OR //* ݃ANZX
                 PAG_COMMIT OR  //* p[R~bg
                 OBJ_GIVEABLE); //* |C^[^悤ɂ
         IF rc=0 THEN BEGIN
             //* eLXgw\[XE|C^[ZbgAbv
             move(pCh^,cCh^,StrLen(pCh)+1);

             //* f[^Nbv{[hNAB */
             WinEmptyClipbrd(Anchor);

             //* |C^[ CF_TEXT `ŃNbv{[h֓nB
             // |C^[ ULONG lłKvB

             b:=WinSetClipbrdData( Anchor,
                                ULong(cCh),// eLXgEf[^w|C^[
                                CF_TEXT, // f[^̓eLXg`
                                CFI_POINTER);// |C^[n

             WinCloseClipbrd(Anchor);
         END;
     END;
end;

PROCEDURE ActiveMenu(hwndFrame:hwnd;ID_ParentMenu,id:ULONG;Active:BOOLEAN);
VAR
    hwndMenu,hwndSubMenu:HWnd;
    mi:MenuItem;
BEGIN
    hwndMenu:=WinWindowFromID(hwndFrame,FID_MENU);
    WinSendMsg(hwndMenu,                  //* j[Eo[̃nh */
         MM_QUERYITEM,                    //* bZ[W        @@@ */
         MPFROM2SHORT(ID_ParentMenu, 1),    //* Tuj[ ID          */
         MParam(@mi));                    //* MENUITEM w|C^[  */

    hwndSubMenu := mi.hwndSubMenu;       //* Tuj[̃nh   */
    IF Active THEN
        WinSendMsg(hwndSubMenu,
                   MM_SETITEMATTR,
                   MPFROM2SHORT(Id,1),
                   MPFROM2SHORT(MIA_DISABLED,1) )
    ELSE
        WinSendMsg(hwndSubMenu,
                   MM_SETITEMATTR,
                   MPFROM2SHORT(Id,1),
                   MPFROM2SHORT(MIA_DISABLED,MIA_DISABLED) );

END;

PROCEDURE InsertSubMenu(hwndFrame:hWnd;
                        ID_ParentMenu,ID_InsertMenu:INTEGER;
                        MenuName:String);
VAR
    mi:MenuItem;
    hwndMenu, hwndSubMenu, hwndPullDown:HWnd;
    rc:mresult;
BEGIN
    hwndMenu := hwndFrame;
    rc:=WinSendMsg( hwndMenu,                //* j[Eo[̃nh */
                    MM_QUERYITEM,            //* bZ[W        @@@ */
                    MPFROM2SHORT(ID_ParentMenu,1),//* Tuj[ ID     */
                    MParam(@mi));            //* MENUITEM w|C^[  */

    hwndPullDown := mi.hwndSubMenu;       //* Tuj[̃nh   */

    mi.iPosition := MIT_END;
    mi.afStyle := MIS_TEXT;
    mi.afAttribute := 0;
    mi.id := ID_InsertMenu;
    mi.hwndSubMenu := 0;
    mi.hItem := 0;

    MenuName:=MenuName+#0;
    rc:=WinSendMsg(hwndPullDown,
            MM_INSERTITEM,
            MParam(@mi),
            MParam(@MenuName[1]));

END;

PROCEDURE RenameMenu(FrameWindow:hWnd;
                    ID_PARENT,ID_Menu:INTEGER;
                    MenuName:string);
VAR
    mi:MenuItem;
    hwndMenu, hwndSubMenu, hwndPullDown:HWnd;
BEGIN
    hwndMenu := FrameWindow;

    WinSendMsg(hwndMenu,
               MM_QUERYITEM,
               MPFROM2SHORT(ID_Parent, 1),
               MParam(@mi));

    hwndPullDown := mi.hwndSubMenu;
    WinSendMsg(hwndPullDown,
                MM_SETITEMTEXT,
                MPFromShort(ID_MENU),
                MParam(@MenuName[1]));
END;

PROCEDURE DeleteMenu(FrameWindow:hWnd;
                      ID_Parent,ID_Menu:INTEGER);
VAR
    mi:MenuItem;
    hwndMenu, hwndSubMenu, hwndPullDown:HWnd;
BEGIN
    hwndMenu := FrameWindow;
    WinSendMsg(hwndMenu,
                MM_QUERYITEM,
                MPFROM2SHORT(ID_Parent, 1),
                MParam(@mi));
    hwndPullDown := mi.hwndSubMenu;
    WinSendMsg(hwndPullDown,
                MM_DELETEITEM,
                MPFrom2Short(ID_MENU,1),
                0);

END;




var
    i:integer;
BEGIN
    for i:=1 to MaxColumList do begin
        DefaultColumToSuffix[i].ix:=i;
        DefaultColumToSuffix[i].isDisp:=TRUE;
    end;
    ErrorMsgWnd:=NullHandle;
END.

strings
bool
false
